 
/****************************************************************
 * FR60 family Monitor Debugger                                 *
 * ALL RIGHTS RESERVED, COPYRIGHT(C) FUJITSU LIMITED 2007       *
 * LICENCED MATERIAL - PROGRAM PROPERTY OF FUJITSU LIMITED      *
 ****************************************************************/

/**
 * @file        main.c
 * @brief       [UCvOTv
 * @par     
 *              j^fobKgp̃[UC֐̃TvłB
 *
 */

#include <stdio.h>
#include "_fr.h"                /* I/O`W[gp      */
#include "extern.h"

/*------------------------------------------------------------------------------*/
/**
 * @brief       j^fobKgp̐؂ւ
 * @par     :
 *              j^fobKgpۂɒ`܂B
 */
/*
#define USE_MODFR60
*/
#define USE_MB91918EB           /* ToDo:ŏIIɍ폜 */


#ifdef USE_MODFR60
#include "modFR60.h"
extern void mod_uart_init( void ) ;
extern void mod_timer_init( void ) ;
#endif


/**********************
 * n[hEFA *
 **********************/

/*------------------------------------------------------------------------------*/
/**
 * @brief       STCRݒl
 * @par     F
 *              STCRݒl̒`łB
 */

#define STCRDAT     0x10

/*------------------------------------------------------------------------------*/
/**
 * @brief       DIVR0ݒl
 * @par     F
@code
 *          [7:4]   B           CPUNbN(CLKB)   0:x1,1:x2,2:x3...15:x16
 *          [3:0]   P           ӃNbN(CLKP)  0:x1,1:x2,2:x3...15:x16
@endcode
 */

#define DIVR0DAT    0x01                /* 40MHz/20MHz              */

/*------------------------------------------------------------------------------*/
/**
 * @brief       DIVR1ݒl
 * @par     F
@code
 *          [7:4]   T           OoXNbN(CLKB)   0:x1,1:x2,2:x3...15:x16
@endcode
 */

#define DIVR1DAT    0x10                /* External 20MHz           */

/*------------------------------------------------------------------------------*/
/**
 * @brief       CLRݒlP
 */

#define CLKRDATA    0x34

/*------------------------------------------------------------------------------*/
/**
 * @brief       CLRݒlQ
 * @par     F
@code
 *          [7]     PLL2S       TuNbN{    0:1{
 *          [6:4]   PLL1S       CPLL{       0:x1,1:x2,2:x3,3:x4
 *          [3]     PLL2EN      TuNbN    0:~, 1:
 *          [2]     PLL1EN      CPLL       0:~, 1:
 *          [1:0]   CLKS        NbN\[X      0,1:X0/X1, 2:CPLL, 3:TuNbN
@endcode
 */

#define CLKRDATB    0x36

/*------------------------------------------------------------------------------*/
/**
 * @brief       n[hEFA
 * @par     F
 *              n[hEFȀłB
 */

void
hardware_init( void )
{
#ifdef USE_MB91918EB                    /* ToDo:̃ubN̏́AŏIIɍ폜 */
    IO_PORT.IO_DDR4.byte = 0xff ;       /* LED port direction output */
    IO_PDR4.byte = 0xff ;               /* LED all OFF */
#endif
    IO_CLK.IO_STCR.byte = STCRDAT ;
    IO_CLK.IO_CLKR.byte = CLKRDATA ;
    IO_CLK.IO_DIVR0.byte = DIVR0DAT ;
    IO_CLK.IO_DIVR1.byte = DIVR1DAT ;
    IO_CLK.IO_CLKR.byte = CLKRDATB ;
}

/*------------------------------------------------------------------------------*/
/**
 * @brief       [U
 * @par     F
 *              ɖړȈLq܂B
 */
/*
void
user_main( void )
{

}
*/

/*------------------------------------------------------------------------------*/
/**
 *  @brief      C֐Tv
 *  @par    :
 *              [UAvP[ṼC֐TvłB
 *  @par
 *              j^fobḰAAZuxINT #10߂ŋN܂B
 *              INT #10߂ɂāAVXe̓G~[V[hœ삵A̎_ŁAvO͎s~ԂƂȂ܂B
 *              𑱂ꍇ́ASoftune WorkbenchŃvO̎ssĂB
 *              j^fobKNȂꍇ́AINT #10߂𔭍sKv͂܂B
 *              ̏ꍇASoftune WorkbenchƂ̘Ag͂ł܂B
 *              j^fobK̋ŃAVXeNɂPx{ĂB
 *              xj^fobK̋NśAVXeZbg܂ŁAĂINT #10߂𔭍sȂłB
 *  @par
 *              TvvOł́Amain֐łbot̃n[hEFAݒĂяoĂ܂A
 *              n[hEFȀ́Ab̏(startup.asm)sOɍsǂꍇ܂B
 *              Ⴆ΁AOɃvO݂ꍇAOoXC^[tF[X̐ݒ͂b̏̑OɍsKv܂B
 *              ܂ANbNݒ́Ab̏̑OɍsقȀXs[hサ܂B
 *              b̏̑OɏsꍇAʏ̓AZuŏLq܂B
 *              {Tvł͔₷̂߁An[hEFȀbŋLqĂ܂B
 */

void
main( void )
{
    hardware_init() ;           /* n[hEFȀ                         */

#ifdef USE_MODFR60
    mod_uart_init() ;           /* zXgʐMpUART(USBɕϊ)      */
    mod_timer_init() ;          /* v^C}                             */
#endif

    __set_il( 31 ) ;            /* ݂̊荞݃}XNx31(Ŏ)ɐݒB */
    __EI() ;                    /* 荞݂̋                               */

#ifdef USE_MODFR60
    __asm( " int #10" ) ;       /* j^fobKN                           */
#endif

    user_main() ;               /* ɖړȈLqB                 */

    for(;;) ;

}



