;==========================================================================
; FR Family SOFTUNE C/C++ Compiler's startup routine (for C program only),
; ALL RIGHTS RESERVED, COPYRIGHT (C) FUJITSU LIMITED 1986-1999
; LICENSED MATERIAL - PROGRAM PROPERTY OF FUJITSU LIMITED
;==========================================================================
; Sample program for initialization
;--------------------------------------------------------------------------

;--------------------------------------------------------------------------
; external declaration of symbols
;--------------------------------------------------------------------------
    .export __start
    .export __exit
    .import _main
    .import _exit
    .import __stream_init
    .import _RAM_INIT
    .import _ROM_INIT

;--------------------------------------------------------------------------
; definition to stack area
;--------------------------------------------------------------------------
#define STACK_SIZE  4*1024-4    ; definition stack size, 4k bytes

    .section    STACK, stack, align=4
    .res.b      STACK_SIZE
stack_top:
    .res.w  1

;--------------------------------------------------------------------------
; definition to start address of data, const and code section
;--------------------------------------------------------------------------
    .section    IO,     io,    align=4
    .section    DATA,   data,  align=4
    .section    INIT,   data,  align=4
    .section    CONST,  const, align=4
    .section    CODE,   code,  align=2
__start:
;--------------------------------------------------------------------------
; set stack pointer register
;--------------------------------------------------------------------------
    ldi #stack_top, sp

;--------------------------------------------------------------------------
; zero clear of DATA section
;--------------------------------------------------------------------------
#macro  FILL04  src_addr
#local  L0, L1, L2, LE
    ldi:8   #0, r0
    ldi #sizeof src_addr &~0x3, r1
    ldi #src_addr, r13
    cmp #0, r1
    beq L1
L0:
    add2    #-4, r1
    bne:d   L0
    st  r0, @(r13, r1)
L1:
    ldi:8   #sizeof src_addr & 0x3, r1
    ldi #src_addr + (sizeof src_addr & ~0x3), r13
    cmp #0, r1
    beq LE
L2:
    add2    #-1, r1
    bne:d   L2
    stb r0, @(r13, r1)
LE:
#endm

    FILL04  DATA

;--------------------------------------------------------------------------
; copy ROM area to RAM area
;--------------------------------------------------------------------------
    ldi #_RAM_INIT, r0
    ldi #_ROM_INIT, r1
    ldi #sizeof(INIT), r2
    cmp #0, r2
    beq:d   copy_rom_end
    ldi #3, r12
    and r2, r12
    beq:d   copy_rom2
    mov r2, r13
    mov r2, r3
    sub r12, r3
copy_rom1:
    add #-1, r13
    ldub    @(r13, r1), r12
    cmp r3, r13
    bhi:d   copy_rom1
    stb r12, @(r13, r0)
    cmp #0, r3
    beq:d   copy_rom_end
copy_rom2:
    add #-4, r13
    ld  @(r13, r1), r12
    bgt:d   copy_rom2
    st  r12, @(r13, r0)
copy_rom_end:

;--------------------------------------------------------------------------
; C library initialize
;--------------------------------------------------------------------------
    call32  __stream_init, r12

start_main:
;--------------------------------------------------------------------------
; call main routine
;--------------------------------------------------------------------------
    ldi:8   #0, r4      ; Set the 1st parameter for main to 0.
    call32:d _main, r12
    ldi:8   #0, r5      ; Set the 2nd parameter for main to NULL.
    call32  _exit, r12
__exit:
end:

;--------------------------------------------------------------------------
; call invalid address for simulator exit
;--------------------------------------------------------------------------
    call32  0xfffffffe,r12
    .end    __start
