const unsigned char DEV_DESC[] = { /* DEVICE_DESCRIPTOR */
		0x12,		/* bLength(18bytes) */
		0x01,		/* bDescriptor(0x01) */
		0x10,0x01,	/* bcdUSB */
		0x00,		/* bDeviceClass */
		0x00,		/* bDeviceSubClass */
		0x00,		/* bDeviceProtocol */
		0x08,		/* bMaxPackerSize0 */
		0x7e,0x0b,	/* idVendor */	/* dH */
		0x00,0x80,	/* idProduct*/	/* USBp */
		0x00,0x01,	/* bcdDevice */
		0x00,		/* iManufacturer */
		0x00,		/* iProduct */
		0x00,		/* iSerialNumer */
		0x01		/* bnumConfigurations */
};
const unsigned char CFG_DESC[] = { /* CONFIG_DESCRIPTOR */
		0x09,		/* bLength(9bytes) */
		0x02,		/* bDescriptor(0x02) */
		0x22,0x00,	/* wToalLength = CONFIG + INTERFACE + ENDPOINT + etc */
		0x01,		/* bNumInterfaces */
		0x01,		/* bConfigurationValue */
		0x01,		/* iConfiguration */
		0x80,		/* bmAttributes */
		0xf0,		/* bMaxPower(N x 2mA) */
		/* INTERFACE_DESCRIPTOR */
		0x09,04,	/* bLength(9bytes),bDescriptor(0x04) */
		0x00,		/* bInterfaceNumber */
		0x00,		/* bAlternateSetting */
		0x01,		/* bNumEndpoints */
		0x03,		/* bInterfaceClass */
		0x01,		/* bInterfaceSubClass */
		0x02,		/* bInterfaceProtocol */
		0x00,		/* iInterface */
		/* ENDPOINT_DESCRIPTOR */
		0x07,05,	/* bLength(7bytes),bDescriptor(0x05) */
		0x83,		/* bEndpointAddress(IN,EPnumber=3) */
		0x03,		/* bmAttributes(Interrupt) */
		0x04,0x00,	/* bMaxPacketSize */
		0x0a,		/* bInterval(10ms) */
		/* HID_DESCRIPTOR */
		0x09,21,	/* bLength(9bytes),bDescriptor(0x21) */
		0x01,0x01,	/* bcdHID */
		0x00,		/* bCountryCode */
		0x01,		/* bNumDescriptors */
		0x22,		/* bDescriptorType */
		0x34,0x00	/* wItemLength */
};
const unsigned char ITF_DESC[] = { /* INTERFACE_DESCRIPTOR */
		0x09,04,	/* bLength(9bytes),bDescriptor(0x04) */
		0x00,		/* bInterfaceNumber */
		0x00,		/* bAlternateSetting */
		0x01,		/* bNumEndpoints */
		0x03,		/* bInterfaceClass */
		0x01,		/* bInterfaceSubClass */
		0x02,		/* bInterfaceProtocol */
		0x00		/* iInterface */
};
const unsigned char END_DESC[] = { /* ENDPOINT_DESCRIPTOR */
		0x07,05,	/* bLength(7bytes),bDescriptor(0x05) */
		0x83,		/* bEndpointAddress(IN,EPnumber=3) */
		0x03,		/* bmAttributes(Interrupt) */
		0x04,0x00,	/* bMaxPacketSize */
		0x0a		/* bInterval(10ms) */
};
const unsigned char HID_DESC[] = { /* HID_DESCRIPTOR */
		0x09,21,	/* bLength(9bytes),bDescriptor(0x21) */
		0x01,0x01,	/* bcdHID */
		0x00,		/* bCountryCode */
		0x01,		/* bNumDescriptors */
		0x22,		/* bDescriptorType */
		0x34,0x00	/* wItemLength */
};
const unsigned char HID_REP[] = { /* HID_REPORT */
		0x05,0x01,
		0x09,0x02,
		0xa1,0x01,
		0x09,0x01,
		0xa1,0x00,
		0x05,0x09,
		0x19,0x01,
		0x29,0x03,
		0x15,0x00,
		0x25,0x01,
		0x95,0x03,
		0x75,0x01,
		0x81,0x02,
		0x95,0x01,
		0x75,0x05,
		0x81,0x01,
		0x05,0x01,
		0x09,0x30,
		0x09,0x31,
		0x09,0x38,
		0x15,0x81,
		0x25,0x7f,
		0x75,0x08,
		0x95,0x03,
		0x81,0x06,
		0xC0,		/* End Collection */
		0xC0		/* End Collection */
};
