/* MB91FV310A USB-Function Sample */

#include "_fr.h"
#include "extern.h"
#include "usbfu.h"
#include "usb_descripter.h"

USBDATA CTRL_OUT[4];	/* CONTROL-OUT data buffer(8byte) */
USB_SEND_BUF usb_send_buffer;

unsigned int cnt = 0;

void USB_init(void)
{
	unsigned int i;
	volatile unsigned char *IPRST;

	IPRST = (unsigned char *)0x0006FFFE;
	*IPRST = 0x40;	/* USB-F-RST assert */
	for(i=0;i<16;i++) __wait_nop();
	*IPRST = 0x00;	/* USB-F-RST negate */

	/* Endpoint Initialize */
	IO_USBF.IO_FIFO2 = 0x0000;
	IO_USBF.IO_FIFO2 = 0x1080;
	IO_USBF.IO_FIFO2 = 0x0014;
	IO_USBF.IO_FIFO2 = 0x2080;
	IO_USBF.IO_FIFO2 = 0x8001;
	IO_USBF.IO_FIFO2 = 0x2428;
	IO_USBF.IO_FIFO2 = 0x8080;
	IO_USBF.IO_FIFO2 = 0x0234;
	IO_USBF.IO_FIFO2 = 0x3810;
	IO_USBF.IO_FIFO2 = 0x8003;

	IO_USBF.IO_CONT1.bit.CFGEN = 1;

	while(!IO_USBF.IO_ST3.bit.CFEND);

	/* FIFO clear */
	IO_USBF.IO_CONT2.bit.INI0o = 1;
	IO_USBF.IO_CONT2.bit.INI0i = 1;
	IO_USBF.IO_CONT2.bit.INI1 = 1;
	IO_USBF.IO_CONT2.bit.INI2 = 1;
	IO_USBF.IO_CONT2.bit.INI3 = 1;

	/* ACK IRQ MASK */
	IO_USBF.IO_CONT7.bit.MACK0o = 1;
	IO_USBF.IO_CONT7.bit.MACK0i = 1;
	IO_USBF.IO_CONT7.bit.MACK1 = 0;
	IO_USBF.IO_CONT7.bit.MACK2 = 0;
	IO_USBF.IO_CONT7.bit.MACK3 = 1;

	/* NACK IRQ MASK */
	IO_USBF.IO_CONT8.bit.MNACK0o = 1;
	IO_USBF.IO_CONT8.bit.MNACK0i = 1;
	IO_USBF.IO_CONT8.bit.MNACK1 = 0;
	IO_USBF.IO_CONT8.bit.MNACK2 = 0;
	IO_USBF.IO_CONT8.bit.MNACK3 = 1;

	/* DMA request Disable */
	IO_USBF.IO_CONT5.bit.DFIFOBUSY2 = 0;
	IO_USBF.IO_CONT5.bit.DFIFOBUSY1 = 0;

	/* FIFO BUSY clear */
	IO_USBF.IO_CONT4.bit.FIFOBUSY0o = 1;
	IO_USBF.IO_CONT4.bit.FIFOBUSY0i = 1;
	IO_USBF.IO_CONT4.bit.FIFOBUSY1 = 0;
	IO_USBF.IO_CONT4.bit.FIFOBUSY2 = 0;
	IO_USBF.IO_CONT4.bit.FIFOBUSY3 = 1;

	/* Interrupt MASK */
	IO_USBF.IO_CONT9.bit.MSTALL0 = 0;
	IO_USBF.IO_CONT9.bit.MSTALL1 = 0;
	IO_USBF.IO_CONT9.bit.MSTALL2 = 0;
	IO_USBF.IO_CONT9.bit.MSTALL3 = 0;
	IO_USBF.IO_CONT9.bit.MUSBRESET = 1;

	IO_USBF.IO_CONT3.bit.BFOK0o = 1;	/* Endpoint0 out Enable */
	IO_USBF.IO_CONT3.bit.BFOK0i = 1;	/* Endpoint0 in Enable */
	IO_USBF.IO_CONT3.bit.BFOK3 = 1;		/* Endpoint3 in Enable */
}

/* INT4/USB interrupt routine */
__interrupt void INT4_int(void)
{
	volatile unsigned char dummy;

	if(IO_USBF.IO_ST1.bit.ACK0o) {	/* FIFO0(CONTROL) OUT ACK */
		IO_USBF.IO_ST1.bit.ACK0o = 1;
		EP0_out();
	}
	else if(IO_USBF.IO_ST1.bit.NACK0o) {	/* FIFO0(CONTROL) OUT NACK */
		IO_USBF.IO_ST1.bit.NACK0o = 1;
	}
	else if(IO_USBF.IO_ST1.bit.ACK0i) {	/* FIFO0(CONTROL) IN ACK */
		IO_USBF.IO_ST1.bit.ACK0i = 1;
		EP0_in();
	}
	else if(IO_USBF.IO_ST1.bit.NACK0i) {	/* FIFO0(CONTROL) IN NACK */
		IO_USBF.IO_ST1.bit.NACK0i = 1;
	}

	if(IO_USBF.IO_ST1.bit.ACK3) {	/* FIFO3(INTERRUPT) IN ACK */
		IO_USBF.IO_ST1.bit.ACK3 = 1;
		cnt = ((cnt + 1) & 0x3f);		/* mouse data count */
		EP3_in();	/* next data setting */
	}
	else if(IO_USBF.IO_ST1.bit.NACK3) {	/* FIFO3(INTERRUPT) IN NACK */
		IO_USBF.IO_ST1.bit.NACK3 = 1;
		EP3_in();	/* first data setting */
	}

	if(IO_USBF.IO_ST5.bit.USBRESET) {
		IO_USBF.IO_ST5.bit.USBRESET = 1;
		IO_USBF.IO_CONT2.bit.INI0o = 1;	/* FIFO Initialize */
		IO_USBF.IO_CONT2.bit.INI0i = 1;	/* FIFO Initialize */
		IO_USBF.IO_CONT2.bit.INI3 = 1;	/* FIFO Initialize */
	}

	/* External Interrupt clear */
	IO_EIRR.bit.ER4 = 0;
	dummy = IO_EIRR.byte;
}

/* Endpoint-0o : CONTROL-OUT */
void EP0_out(void)
{
	unsigned short RSIZE0; /* CONTROL OUT data size */
	volatile unsigned char dummy;
	int i;

	RSIZE0 = IO_USBF.IO_RSIZE0.hword;	/* CONTROL OUT size */
	for(i=0;i<((RSIZE0+1)/2);i++) {
		CTRL_OUT[i].hword = IO_USBF.IO_FIFO0o;
	}
	IO_USBF.IO_CONT3.bit.BFOK0o = 1;
	if(RSIZE0 > 0) {
		if(IO_USBF.IO_ST3.bit.SETUP) {
			switch(CTRL_OUT[0].hword) {	/* {bmRequestType,bRequest} */
				case 0x8006:	/* GET_DESCRIPTOR */
					send_descriptor();
					break;
				case 0x8106:	/* GET_DESCRIPTOR(HID) */
					send_descriptor();
					break;
				case 0x8206:	/* GET_DESCRIPTOR(HID) */
					send_descriptor();
					break;
				case 0x0007:	/* SET_DESCRIPTOR */
					break;
				case 0x820C:	/* SYNC_FRAME */
					break;
			}
		}
	}
	else {	/* Null */
		IO_USBF.IO_CONT2.bit.INI0i = 1;		/* EP0-IN FIFO clear */
	}
}

void send_descriptor(void)
{
	unsigned int i;
	unsigned short desc_type;
	unsigned short req_size,desc_size;
	unsigned char *desc_top;

	desc_type = CTRL_OUT[1].hword;	/* wValue */
	req_size = ((CTRL_OUT[3].byte.LB << 8) | CTRL_OUT[3].byte.UB);	/* wLength */
	switch(desc_type) {
		case 0x0001: /* DEVICE DESCRIPTOR */
			desc_size = (unsigned short)DEV_DESC[0];
			desc_top = (unsigned char *)DEV_DESC;
			break;
		case 0x0002: /* CONFIGURATION DESCRIPTOR */
/*			desc_size = (unsigned short)CFG_DESC[0]; */
			desc_size = (unsigned short)((CFG_DESC[3] << 8) | CFG_DESC[2]);
			desc_top = (unsigned char *)CFG_DESC;
			break;
		case 0x0004: /* INTERFACE DESCRIPTOR */
			desc_size = (unsigned short)ITF_DESC[0];
			desc_top = (unsigned char *)ITF_DESC;
			break;
		case 0x0005: /* ENDPOINT DESCRIPTOR */
			desc_size = (unsigned short)END_DESC[0];
			desc_top = (unsigned char *)END_DESC;
			break;
		case 0x0021: /* HID DESCRIPTOR */
			desc_size = (unsigned short)HID_DESC[0];
			desc_top = (unsigned char *)HID_DESC;
			break;
		case 0x0022: /* HID REPORT */
			desc_size = (unsigned short)sizeof(HID_REP);
			desc_top = (unsigned char *)HID_REP;
			break;
		default:
			__wait_nop();
			break;
	}
	if(req_size >= desc_size)
		usb_send_buffer.tr_num = desc_size;
	else
		usb_send_buffer.tr_num = req_size;

	usb_send_buffer.tr_pointer = 0;
	for(i=0;i<(usb_send_buffer.tr_num + 1)/2;i++) {
		usb_send_buffer.tr_data[i].byte.UB = *(desc_top++);
		usb_send_buffer.tr_data[i].byte.LB = *(desc_top++);
	}

	EP0_in();
}

/* Endpoint-0i : CONTROL-IN */
void EP0_in(void)
{
	unsigned int i;
	unsigned short ttsize;
	unsigned int f_last,f_odd;

	ttsize = usb_send_buffer.tr_num;
	if(ttsize > 0) {
		if(ttsize <= 8) {
			f_last = 1; /* Last Packet */
			usb_send_buffer.tr_num = 0;
		} else { /* ttsize > 8 */
			f_last = 0;
			ttsize = 8;
			usb_send_buffer.tr_num -= 8;
		}
		if(ttsize & 1)
			f_odd = 1; /* Odd Packet */
		else
			f_odd = 0;
		for(i=1;i<=((ttsize+1)/2);i++) {
			if(i == ((ttsize+1)/2)) {
				if(f_last)
					IO_USBF.IO_CONT10.bit.LSTD0 = 1;
				if(f_odd)
					IO_USBF.IO_CONT10.bit.ODD = 1;
			}
			IO_USBF.IO_FIFO0i = usb_send_buffer.tr_data[usb_send_buffer.tr_pointer++].hword;
		}
	}
	IO_USBF.IO_CONT3.bit.BFOK0i = 1;
}

/* Endpoint-3 : INTERRUPT-IN */
void EP3_in(void)
{
	unsigned int i;
	unsigned short ttsize;

	LED_on();

	USB_mouse_data_set();

	ttsize = usb_send_buffer.tr_num;
	if(ttsize > 0) {
		if(ttsize > 8) {
			ttsize = 8;
			usb_send_buffer.tr_num -= 8;
		}
		else
			usb_send_buffer.tr_num = 0;

		for(i=1;i<=((ttsize+1)/2);i++) {
			if(i == ((ttsize+1)/2)) {
				if(ttsize & 1) {
					IO_USBF.IO_CONT10.bit.ODD = 1;
				}
				IO_USBF.IO_CONT10.bit.LSTD3 = 1;
				IO_USBF.IO_FIFO3 = usb_send_buffer.tr_data[usb_send_buffer.tr_pointer++].hword;
			}
			else
				IO_USBF.IO_FIFO3 = usb_send_buffer.tr_data[usb_send_buffer.tr_pointer++].hword;
		}
	}
	IO_USBF.IO_CONT3.bit.BFOK3 = 1; 

	LED_off();
}

void USB_mouse_data_set(void)
{
	usb_send_buffer.tr_num = 4;	/* wLength */
	usb_send_buffer.tr_pointer = 0;	/* wIndex */
	usb_send_buffer.tr_data[0].byte.UB = 0x01;	/* byte-0:Button */
	usb_send_buffer.tr_data[1].byte.LB = 0x00;	/* byte-3:dummy */

	if(cnt < 0x10) {
		usb_send_buffer.tr_data[0].byte.LB = 0x02;	/* byte-1:x */
		usb_send_buffer.tr_data[1].byte.UB = 0x04;	/* byte-2:y */
	}
	else if(cnt < 0x20) {
		usb_send_buffer.tr_data[0].byte.LB = 0x04;	/* byte-1:x */
		usb_send_buffer.tr_data[1].byte.UB = 0x02;	/* byte-2:y */
	}
	else if(cnt < 0x30) {
		usb_send_buffer.tr_data[0].byte.LB = 0xfe;	/* byte-1:x */
		usb_send_buffer.tr_data[1].byte.UB = 0xfc;	/* byte-2:y */
	}
	else if(cnt < 0x3f) {
		usb_send_buffer.tr_data[0].byte.LB = 0xfc;	/* byte-1:x */
		usb_send_buffer.tr_data[1].byte.UB = 0xfe;	/* byte-2:y */
	}
	else {
		usb_send_buffer.tr_data[0].byte.LB = 0x02;	/* byte-1:x */
		usb_send_buffer.tr_data[1].byte.UB = 0x04;	/* byte-2:y */
	}
}
